﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;



namespace WindowsFormsApplication1
{

    public delegate void ScannerCallback(int DIBHandle);

   

    public partial class Form1 : Form
    {
        //Declare some variables
        int GrayDIBHandle;
        public int ScannedImages;

        //Inizialize some variables
        int Session = 0;
        public const int CF_DIB = 8;

        public Form1()
        {
            InitializeComponent();
        }

        //load, display and copy button
        private void button1_Click(object sender, EventArgs e)
        {
            int hBitmap;
            hBitmap = 0;

            //load image
            hBitmap = ImagingDemo.RecoIO.IO_LoadTIFImage(Session, ".\\test.tif", 0);
            Graphics g = pictureBox1.CreateGraphics();        
            IntPtr hDC = g.GetHdc();

            //show image in pictureBox1
            ImagingDemo.RecoIO.IO_ShowImage(Session, hBitmap, hDC.ToInt32(), 0, 0);
            ImagingDemo.RecoIO.IO_SavePDFImage(Session, hBitmap, ".\\scan.pdf", 80);
            Graphics f = pictureBox2.CreateGraphics();
            IntPtr hDC1 = f.GetHdc();

            // Create a 25% scaled gray image
            GrayDIBHandle = ImagingDemo.RecoIO.IO_GetScaleToGrayImage(Session, hBitmap, 25);
            // Show the gray image
            ImagingDemo.RecoIO.IO_ShowImage(Session, GrayDIBHandle, hDC1.ToInt32(), 0, 0);
            // Free the gray image
            ImagingDemo.RecoIO.IO_FreeImage(Session, GrayDIBHandle);
            if (hBitmap > 0)
            {
                // Open the Clipboard
                ImagingDemo.Clipbrd.OpenClipboard(this.Handle.ToInt32());

                // Save the DIB to the clipboard 
                ImagingDemo.Clipbrd.SetClipboardData(CF_DIB, hBitmap);

                // Close the Clipboard	
                ImagingDemo.Clipbrd.CloseClipboard();

                MessageBox.Show("Image loaded and copied in clipboard !", "INFO");
            }
            else
            {
                // Show an error message
                MessageBox.Show("Unable to load the image", "ERROR");
            }
        }
        
        //Select scanner to use
        private void button2_Click(object sender, EventArgs e)
        {
            // Allow user to select a scanner
            ImagingDemo.RecoIO.IO_SelectScanner(Session, 0);
        }

        //Acquire using UI
        private void button3_Click(object sender, EventArgs e)
        {
            
            // Start scanning
            int DIBHandle = 0;
            
            ImagingDemo.RecoIO.IO_SetScannerCallback(Session, new ScannerCallback(MyCallback));
            DIBHandle=ImagingDemo.RecoIO.IO_ScanImage(Session, this.Handle.ToInt32());
            if (DIBHandle != 0)
            {
                // Free image from memory
                ImagingDemo.RecoIO.IO_FreeImage(Session, DIBHandle);
                // Increase the page counter
                MessageBox.Show("Images acquired in file .\\scan.tif !", "INFO");
            }
        }

        private void MyCallback(int DIBHandle)
        {
            //MessageBox.Show("Received callback. DIBHandle: " + DIBHandle);
            ScannedImages = ScannedImages + 1;
            //MessageBox.Show("1", "INFO");
            // Save the image as scan1.tif scan2.tif scanxxxx.tif in current directory
            // IO_SaveTIFImage IOSession, DIBHandle, ".\scan" & ScannedImages & ".tif", 0
            // Save the image as scan1.tif scan2.tif scanxxxx.tif in current directory
            ImagingDemo.RecoIO.IO_SavePDFImage(Session, DIBHandle, ".\\scan" + ScannedImages + ".pdf", 80);
        }

        //Acquire no UI
        private void button4_Click(object sender, EventArgs e)
        {
            int ScannedDIB;
            // Acquire a single A4 200 DPI B&W with flatbed
            ScannedDIB = ImagingDemo.RecoIO.IO_ScanImageWithParameters(Session, 1, 200, 0, 0, (8.5*72), (11.25*72), 0, 0);
            // Save the image
            if (ScannedDIB != 0) 
            {
                // Save the image
                ImagingDemo.RecoIO.IO_SaveTIFImage(Session, ScannedDIB, ".\\scan.tif", 0);
                // Free the image from memory
                ImagingDemo.RecoIO.IO_FreeImage(Session, ScannedDIB);
                // Show the message
                MessageBox.Show("Scanned a 612 x 810 points image at 200 DPI in black&white with default contrast and brightness, from flatbed: saved in scan.tif file !");
            }
        }

        private void Form1_closing(object sender, FormClosingEventArgs e)
        {
            // Destroy the session
            ImagingDemo.RecoIO.IO_Done(Session);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
             // Create an IO session
             Session = ImagingDemo.RecoIO.IO_Init("demo", "demo");
             // Init the counter of scanned images
             ScannedImages = 0;
        }

        private void button5_Click(object sender, EventArgs e)
        {
           // MessageBox.Show("MAke pdf");
            ImagingDemo.RecoIO.IO_MakeSearchablePDF(Session,".\\test.tif",".\\test.xml",".\\test.pdf","Test");
        }

        private void button6_Click(object sender, EventArgs e)
        {
             // Set the scanner callback
             ImagingDemo.RecoIO.IO_SetScannerCallback(Session, new ScannerCallback(MyCallback));
             // Scan images
             ImagingDemo.RecoIO.IO_ScanImageTSPFile(Session,".\\test.tsp");
             // Show message
             MessageBox.Show("Images scanned as files .\\scanXX.pdf");
        }
    }
}
